/* 	$Id: id3tag.h,v 1.1.1.1 2000/01/30 16:39:11 benediktroth Exp $	 */

#ifndef __ID3TAG_H__
#define __ID3TAG_H__


#define GENRE_MAX (sizeof(id3tag_genre_names)/sizeof(id3tag_genre_names[0]))


struct id3tag
{
   char tag[4];
   char title[31];
   char artist[31];
   char album[31];
   char year[5];
   char comment[31];
   char genre;
};

static char *id3tag_genre_names[]=
{
   		  "Blues", 
             	  "Classic Rock",
                  "Country",
                  "Dance",
                  "Disco",
                  "Funk",
                  "Grunge",
                  "Hip-Hop", 
                  "Jazz",
                  "Metal",
                  "New Age",
                  "Oldies",
                  "Other", 
                  "Pop",
                  "R&B",
                  "Rap",
                  "Reggae", 
                  "Rock",
                  "Techno",
                  "Industrial",
                  "Alternative", 
                  "Ska",
                  "Death Metal", 
                  "Pranks",
                  "Soundtrack",
                  "Euro-Techno", 
                  "Ambient",
                  "Trip-Hop", 
                  "Vocal",
                  "Jazz+Funk", 
                  "Fusion",
                  "Trance",
                  "Classical",
                  "Instrumental", 
                  "Acid",
                  "House",
                  "Game",
                  "Sound Clip", 
                  "Gospel",
                  "Noise",
                  "Alt. Rock", 
                  "Bass",
                  "Soul",
                  "Punk",
                  "Space",
                  "Meditative",
                  "Instrumental Pop",
                  "Instrumental Rock", 
                  "Ethnic",
                  "Gothic",
                  "Darkwave",
                  "Techno-Industrial", 
                  "Electronic", 
                  "Pop-Folk",
                  "Eurodance", 
                  "Dream",
                  "Southern Rock", 
                  "Comedy", 
                  "Cult",
                  "Gangsta",
                  "Top 40",
                  "Christian Rap", 
                  "Pop/Funk", 
                  "Jungle",
                  "Native American", 
                  "Cabaret",
                  "New Wave",
                  "Psychadelic", 
                  "Rave",
                  "Showtunes", 
                  "Trailer",
                  "Lo-Fi",
                  "Tribal",
                  "Acid Punk",
                  "Acid Jazz", 
                  "Polka",
                  "Retro",
                  "Musical",
                  "Rock & Roll", 
                  "Hard Rock", 
                  "Folk",
                  "Folk/Rock",
                  "National Folk", 
                  "Swing",
                  "Fusion",
                  "Bebob",
                  "Latin",
                  "Revival",
                  "Celtic",
                  "Bluegrass",
                  "Avantgarde",
                  "Gothic Rock",
                  "Progressive Rock",
                  "Psychedelic Rock", 
                  "Symphonic Rock", 
                  "Slow Rock",
                  "Big Band", 
                  "Chorus",
                  "Easy Listening", 
                  "Acoustic", 
                  "Humour",
                  "Speech",
                  "Chanson", 
                  "Opera",
                  "Chamber Music", 
                  "Sonata",
                  "Symphony",
                  "Booty Bass", 
                  "Primus",
                  "Porn Groove", 
                  "Satire",
                  "Slow Jam", 
                  "Club",
                  "Tango",
                  "Samba",
                  "Folklore",
		  "Ballad",
		  "Power Ballad",
		  "Rhythmic Soul",
		  "Freestyle",
		  "Duet",
		  "Punk Rock",
		  "Drum Solo",
		  "Acapella",
		  "Euro-House",
		  "Dance Hall",
};

extern char *id3tag_genres_sorted[GENRE_MAX+1];

int           id3tag_initialize( struct id3tag *tag );
struct id3tag id3tag_get( char *filename );
struct id3tag id3tag_get_from_filename( char *filename, char *part1, char *part2, char seperator, int mptc );
int           id3tag_show( struct id3tag tag );
int           id3tag_new( char *filename );
int           id3tag_remove( char *filename );
int           id3tag_set( char *filename, struct id3tag tag );
int           id3tag_rename( char *filename, char *format );
int           id3tag_sort( char *filename, char *rootdir, char *format_level1, char *format_level2 );
int           id3tag_cmp( struct id3tag tag1, struct id3tag tag2, int mode);

void id3tag_cut( char *string );
void id3tag_fill( char *string, int end );
void id3tag_lower( char string[] );
void id3tag_sort_genres( void );

const char *id3tag_get_genre( const unsigned char genre_core );
const char id3tag_lookup_genre( const char *genre );

int id3tag_is_valid( struct id3tag tag );
#endif
