/* 	$Id: yamt.h,v 1.1.1.1 2000/01/30 16:39:25 benediktroth Exp $	 */

#ifndef __YAMT_H__
#define __YAMT_H__

#include <config.h>
#include <gnome.h>

#include "properties.h"
#include "mpeg_format.h"
#include "id3tag.h"

#define YAMT_LOGO "yamt/yamt-logo.png"
#define YAMT_ICON "yamt/yamt-icon.png"
#define BUFFERSIZE 80

/* yamt log levels */
#define YLL_DBG -1
#define YLL_LOW 0
#define YLL_MED 1
#define YLL_HIG 2

#define YLL_WRN 3
#define YLL_ERR 4


GtkWidget *app;
  GtkWidget *logwidget;
  GtkWidget *appbar;
GtkWidget *notebook;


/* Here is the current selected directory stored */
/* Controlled by tree_selection_changed() */
gchar *selected_directory;

gfloat progress;


/* yamt.c */
GtkWidget *logo_box_new( void );
GtkWidget *yamtlog_box_new( void );
void yamtlog_show( GtkWidget *widget, gpointer *data );
void yamtlog_clear( GtkWidget *widget, gpointer *data );
void tree_selection_changed( GtkWidget *widget, gpointer *data);
void page_switched( GtkWidget *widget, GtkNotebookPage *page, gint page_num);
void yamt_exit( void );


/* common.c */
void destroy( GtkWidget *widget, gpointer *data );
void yamtlog( gchar *fmt, ...);
int play_file( gchar *file );
gint update_progress_bar( void );
gint menu_popup( GtkWidget *widget, GdkEvent *event);
void expand_variables_in_string(gchar *s, guint size, gchar *dir, gchar *fname);
struct id3tag expand_variables(struct id3tag tag, gchar *dir, gchar *fname);
int mp3_is_valid( gchar *filename );
int get_header_data( char *filename, struct mpegformat_t *header );

#endif
